/* BdfServer_Get - Copyright (c) 2026 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.get.access.v1;

import fr.exemole.bdfserver.json.ColDefJson;
import java.io.IOException;
import java.util.List;
import net.fichotheque.exportation.table.ColDef;
import net.fichotheque.exportation.table.ColDefTitleProvider;
import net.mapeadores.util.json.JSONWriter;
import net.mapeadores.util.json.JsonProperty;


/**
 *
 * @author Vincent Calame
 */
public class InfoJsonProperty implements JsonProperty {

    private final List<ColDef> colDefList;
    private final ColDefTitleProvider colDefTitleProvider;

    public InfoJsonProperty(List<ColDef> colDefList, ColDefTitleProvider colDefTitleProvider) {
        this.colDefList = colDefList;
        this.colDefTitleProvider = colDefTitleProvider;
    }

    @Override
    public String getName() {
        return "info";
    }

    @Override
    public void writeValue(JSONWriter jw) throws IOException {
        jw.object();
        jw.key("columns");
        jw.array();
        for (ColDef colDef : colDefList) {
            jw.object();
            ColDefJson.properties(jw, colDef, colDefTitleProvider);
            jw.endObject();
        }
        jw.endArray();
        jw.endObject();
    }

}
